Bug 467048 - Discarding the key events and same output regardless of the key
Discarding the key events and same output regardless of the key
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: ibus (Show other bugs)
10
All Linux
medium Severity medium
: ---
: ---
Assigned To: Peng Huang
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-15 09:36 EDT by Akira TAGOH
Modified: 2008-12-18 00:20 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-12-18 00:20:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Akira TAGOH 2008-10-15 09:36:09 EDT
+++ This bug was initially created as a clone of Bug #466657 +++

Description of problem:
key input too faster and too much messes up IBus.

Version-Release number of selected component (if applicable):
ibus-0.1.1.20081006-3.fc10

Steps to Reproduce:
1.input something too much and too faster
2.
3.
  
Actual results:
discarding the key event or return the same key event regardless of what pressing/releasing the key.

Expected results:
should works expectedly.

Additional info:
Technically it happens when multiple XIM_FORWARD_EVENT is added to the property when the key event is delivered faster than processing it in IBus. and when it's there more than 4 in the property, it results the same output regardless of what you are pressing/releasing the key. otherwise the key event is discarded.
Why it returns the same key event when the property has something more than 4, IMdkit is getting the value from the property wrongly. a quote from man page:

int XGetWindowProperty(Display *display, Window w, Atom property, long
       long_offset, long long_length, Bool delete, Atom reg_type, Atom
       *actual_type_return, int *actual_format_return, unsigned long
       *nitems_return, unsigned long *bytes_after_return, unsigned char
       **prop_return);
...
long_length
          Specifies the length in 32-bit multiples of the data to be
          retrieved.

and XGetWindowProperty won't delete the property value even if "delete" is True, when there are still unread data.

To do the right thing, read the data with the proper length to not discard the event. and if there are still the unread data in the property, read next data with "long_offset".

--- Additional comment from shawn.p.huang@gmail.com on 2008-10-13 23:07:48 EDT ---

Could you provide a patch to fix XIM problem? Thanks.

--- Additional comment from tagoh@redhat.com on 2008-10-14 06:43:58 EDT ---

Created an attachment (id=320277)
test code for discarding the key event issue

% gcc scim_discarding.c `pkg-config --cflags --libs gtk+-2.0 gio-2.0`
% GTK_IM_MODULE=xim XMODIFIERS=@im=SCIM ./a.out

After pressing the button, "ab" should be put on the entry. otherwise SCIM may be discarding the forward event.

--- Additional comment from tagoh@redhat.com on 2008-10-14 06:47:45 EDT ---

Created an attachment (id=320278)
test code for output the same result regardless of the key

% gcc scim_repeat.c `pkg-config --cflags --libs gtk+-2.0 gio-2.0`
% GTK_IM_MODULE=xim XMODIFIERS=@im=SCIM ./a.out

After pressing the button, "abc" should be put to the entry box. but actual result is "aaaaaa". this testing code is sending KeyPress and KeyRelease events for "a", "b" and "c". and usually GTK+ and other toolkits doesn't take any actions for KeyRelease event. thus, this means SCIM sends back the forward event for "a" with KeyPress 6 times.

--- Additional comment from tagoh@redhat.com on 2008-10-15 05:05:18 EDT ---

Created an attachment (id=320407)
test code for discarding the key event issue

missed one ClientMessage event

--- Additional comment from tagoh@redhat.com on 2008-10-15 07:18:44 EDT ---

Created an attachment (id=320412)
proposed patch
Comment 1 Peng Huang 2008-10-15 22:49:08 EDT
Fixed in ibus-0.1.1.20081016-1.fc10. Thanks.
Comment 2 Bug Zapper 2008-11-25 22:53:23 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Jens Petersen 2008-12-17 23:53:59 EST
Can we close this now?
Comment 4 Akira TAGOH 2008-12-18 00:20:00 EST
Yes, we can.

Note You need to log in before you can comment on or make changes to this bug.